      subroutine linepro(line_in,nword,words,nfloat,floats,maxword)
      implicit real*8(a-h,o-z)
C
C  Subroutine searches a line for words and numbers
C  Now amended to handle full 80 character string.
C
C   2/95 Ability to handle continuation lines added
C   4/98 Now reads from channel 4 as input is preprocessed
C
C  Copyright Imperial College 1997
C
C  Julian Gale, Imperial College, February 1995
C
      dimension words(maxword),floats(maxword)
      character*81 line
      character*80 line_in
      character*30 words
      character*40 string,blank
      character*1 c1,c2,space,dp,hash,contchar,slash
      logical lspace,lfirst,lcontinuation,lread,lword
      data blank/'                                        '/
      contchar='&'
      dp='.'
      hash='#'
      space=' '
      slash='/'
      i0=ichar('0')
      i9=ichar('9')
      ineg=ichar('-')
      ipos=ichar('+')
      ia=ichar('a')
      iz=ichar('z')
      ica=ichar('A')
      icz=ichar('Z')
      nword=0
      nfloat=0
      lread=.false.
   10 if (lread) then
        read(4,'(a)',end=100)line_in
      endif
      line=line_in
      line(81:81)=' '
      lfirst=(line(1:1).ne.space)
      lread=.true.
      icontin=index(line,contchar)
      lcontinuation=(icontin.ne.0)
      if (lcontinuation) then
C
C  Blank out anything after continuation character to 
C  avoid processing comments
C
        do i=icontin,80
          line(i:i)=' '
        enddo
      endif
C*******************
C  Locate strings  *
C*******************
      ilower=1
      iupper=index(line,'#')
      if (iupper.eq.0) iupper=80
      do while (ilower.lt.iupper)
        lspace=.false.
        i=ilower-1
C
C  Find space before alphanumeric character
C
        if (lfirst) then
          i=0
          nstart=1
          lfirst=.false.
          lspace=.true.
        else
          do while (.not.lspace.and.i.lt.iupper)
            i=i+1
            c1=line(i:i)
            c2=line(i+1:i+1)
            if (c1.eq.space.and.c2.ne.space) then
              lspace=.true.
            endif
          enddo
          nstart=i+1
        endif
C
C  Find last alphanumeric character
C
        do while (lspace.and.i.lt.iupper)
          i=i+1
          c1=line(i:i)
          c2=line(i+1:i+1)
          if (c1.ne.space.and.(c2.eq.space.or.c2.eq.hash)) then
            lspace=.false.
          endif
        enddo
        nend=i
        nlen=nend-nstart+1
        if (nstart.lt.iupper) then
C**********************************************
C  Decide what type of string has been found  *
C**********************************************
          string=blank
          string=line(nstart:nend)
          c1=string(1:1)
          if (c1.eq.dp) then
            c1=string(2:2)
          endif
          ic=ichar(c1)
          lword=((ic.lt.i0.or.ic.gt.i9).and.ic.ne.ineg.and.ic.ne.ipos)
C
C  Are there more than two letters in the string - if so this is a word
C
          nsw=0
          do i=1,nlen
            ii=ichar(string(i:i))
            if (ii.ge.ia.and.ii.le.iz) nsw=nsw+1
            if (ii.ge.ica.and.ii.le.icz) nsw=nsw+1
          enddo
          if (nsw.ge.2) lword = .true.
C
          if (lword) then
C*********
C  Word  *
C*********
            nword=nword+1
            if (nword.gt.maxword) then
              write(6,'(/,''  **** Error - too many words - incr'',
     *          ''ease maxword ****'',/)')
              stop
            endif
            words(nword)=string
          else
C***********
C  Number  *
C***********
            nfloat=nfloat+1
            if (nfloat.gt.maxword) then
              write(6,'(/,''  **** Error - too many words - incr'',
     *          ''ease maxword ****'',/)')
              stop
            endif
            islash=(index(string,slash))
            if (islash.ne.0) then
C
C  Fractions
C
              ndp=islash
            else
C
C  Floating point
C
              ndp=index(string,'.')
            endif
            call wtof(string,rnum,nlen,ndp)
            floats(nfloat)=rnum
          endif
        endif
C
C  Set values for next search
C
        ilower=nend+1
      enddo
      if (lcontinuation) then
        goto 10
      else
        return
      endif
  100 write(6,'(/,''  **** Warning - continuation character'',
     *  '' on last line of input ****'',/)')
      return
      end

      subroutine wtof(string,rnum,nlen,ndp)
      implicit real*8(a-h,o-z)
C
C  Convert string to floating point number
C
C  nlen = length of string
C  ndp  = position of decimal point
C
C   9/92 Created
C   3/97 Handling of fractions added
C
C  Copyright Imperial College 1997
C
C  Julian Gale, Imperial College, March 1997
C
      character*1 c
      character*40 string
      logical lneg,lnegp
      npower=0
      i0=ichar('0')
      ineg=ichar('-')
      ipos=ichar('+')
C
C  Look for exponentiation
C
      lnegp=.false.
      nexp=index(string,'e')
      if (nexp.eq.0) nexp=index(string,'E')
      if (nexp.eq.0) nexp=index(string,'d')
      if (nexp.eq.0) nexp=index(string,'D')
      if (nexp.gt.0.and.nexp.lt.nlen) then
C
C  Exponential found
C
        nse=nexp+1
        if (index(string(nse:nse),'+').eq.1) then
          nse=nse+1
        elseif (index(string(nse:nse),'-').eq.1) then
          nse=nse+1
          lnegp=.true.
        endif
        nfct=1
        do i=nlen,nse,-1
          c=string(i:i)
          ic=ichar(c)
          n=ic-i0
          npower=npower+nfct*n
          nfct=nfct*10
        enddo
        nlen=nexp-1
        if (lnegp) npower=-npower
      endif
      rnum=0.0d0
      if (nlen.eq.0) return
      factor=0.1d0
      if (ndp.eq.0) ndp=nlen+1
      nend=1
      c=string(1:1)
      ic=ichar(c)
      if (ic.eq.ineg.or.ic.eq.ipos) nend=2
      lneg=(ic.eq.ineg)
      if (lneg) nend=2
C
C  In front of decimal point
C
      do i=ndp-1,nend,-1
        c=string(i:i)
        ic=ichar(c)
        n=ic-i0
        factor=factor*10.0d0
        rnum=rnum+factor*n
      enddo
C
C  After decimal point
C
      factor=1.0d0
      if (string(ndp:ndp).eq.'/') then
        rnum2=0.0d0
        do i=nlen,ndp+1,-1
          c=string(i:i)
          ic=ichar(c)
          n=ic-i0
C
C  The following condition is to avoid problems with tab characters
C
          if (n.ge.0.and.n.le.9) then
            rnum2=rnum2+factor*n
            factor=factor*10.0d0
          else
C
C  If non-numeric character has been found then exit as this is really
C  a string
C
            return
          endif
        enddo
        if (rnum2.ne.0.0d0) then
          rnum=rnum/rnum2
        else
          write(6,'(''**** Error - zero in fraction ****'')')
          stop
        endif
      else
        do i=ndp+1,nlen
          c=string(i:i)
          ic=ichar(c)
          n=ic-i0
C
C  The following condition is to avoid problems with tab characters
C
          if (n.ge.0.and.n.le.9) then
            factor=factor*0.1d0
            rnum=rnum+factor*n
          endif
        enddo
      endif
      if (lneg) rnum=-rnum
      rnum=rnum*(10.0d0**npower)
      return
      end
